C***********************************************************************
C $Id: arfpar.f,v 3.3 2009/04/20 10:08:05 nils Exp $

      SUBROUTINE ARFPAR(IEXCLP, INEXCL ,IPAR, INP, SBP)

C...ARiadne subroutine Find PARtons that are not proton remains and
C...do not include the partons EXCLP

C...Returns a vector of particle ids the number of particles and a sum
C...of their four-vectors and masses.

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'
      INCLUDE 'ardat1.f'

      DIMENSION IPAR(MAXPAR), SBP(5), IEXCLP(INEXCL)

      INP = 0
      DO 110 I = 1,5
        SBP(I) = 0
 110  CONTINUE

      DO 100 I = 1,IPART
        IF(QEX(I)) GOTO 100
        DO 140 J = 1,INEXCL
          IF (I .EQ. IEXCLP(J)) GOTO 100
 140    CONTINUE
        INP = INP+1
        IPAR(INP) = I
        DO 120 J = 1,4
          SBP(J) = SBP(J) + BP(I, J)
 120    CONTINUE
 100  CONTINUE

      IF(QQ(MAXPAR-2)) THEN
        DO 150 J = 1,INEXCL
          IF (MAXPAR-2 .EQ. IEXCLP(J)) GOTO 160
 150    CONTINUE
        INP = INP+1
        IPAR(INP) = MAXPAR-2
        DO 130 J = 1,4
          SBP(J) = SBP(J) + BP(MAXPAR-2, J)
 130    CONTINUE
      ENDIF
 160  CONTINUE

      SBP(5)=SQRT(MAX(SBP(4)**2-SBP(1)**2-SBP(2)**2-SBP(3)**2, 0.0D0))

C**** END OF ARFPAR ****************************************************
      END

      SUBROUTINE ARFPA3(I1, I2, I3, IPAR, INP, SBP)
      
      INCLUDE 'arimpl.f'
      DIMENSION I(3)

      I(1)=I1
      I(2)=I2
      I(3)=I3
      
      CALL ARFPAR(I, 3, IPAR, INP, SBP)

C**** END OF ARFPA3 ****************************************************
      END
